   program test;
   Uses Crt;
   const k=2; rh0=0.1; delta=0.001; min=1e-307;
   type massiv= array[1..k] of real;
   var d,spsi : real;
       i,j,max : integer;
       psi : massiv;


     function S(psi:massiv):real;
     begin
       s:=sqr(psi[1]-2) + sqr(psi[2]-5);
     end;
{-----------------------------------------------------------------------}
     procedure directsearch(k:integer; rho,delta,min: real;
                   var d,spsi : real; max: integer;var psi: massiv);
   { algorithm 178b   }
     label 1,2,10,1000;
     var sphi,ss,theta : real;
         i,eval :        integer;
         boll   :        Boolean;
         phi,s1 :        massiv;    { array[1..nn] of real; }
     procedure test(var bol: Boolean);
     begin bol:=false;
     if eval<max then eval:=eval+1 else begin bol:=true; write('11') end
{          goto 1000       }
     end;
     procedure ee(var bolle: Boolean);
     var i : integer;
     begin
     for i:=1 to k do
     begin phi[i]:=phi[i]+s1[i]; bolle:=false;
        sphi:=s(phi);  eval:=eval+1;
        if sphi<ss then ss:=sphi else
           begin s1[i]:=-s1[i];
              phi[i]:=phi[i]+2.0*s1[i];
              test(boll); if boll then bolle:=true;
              sphi:=s(phi);
              if sphi<ss  then ss:=sphi else
                 phi[i]:=phi[i]-s1[i]
           end
     end;{i}
     end;{ee}
{start:}
     begin
        for i:=1 to k do
           begin s1[i]:=d*abs(psi[i]);
              if s1[i]<min then s1[i]:=d
           end;
        spsi:=s(psi); eval:=1;
   1:   ss:=spsi;
        for i:=1 to k do phi[i]:=psi[i];
        ee(boll);if boll then goto 1000;
{       writeln(' pass 1-2');      }
        if ss<spsi then
           begin
   2:         for i:=1 to k do
                begin
                  if (phi[i]>psi[i])=(s1[i]<0) then
                     s1[i]:=-s1[i];
                  theta:=psi[i]; psi[i]:=phi[i];
                  phi[i]:=2.0*phi[i]-theta
                end; {i}
              spsi:=ss; test(boll); if boll then goto 1000; ss:=s(phi);
              sphi:=ss; ee(boll); if boll then goto 1000;
              if ss>= spsi then goto 1;
              for i:=1 to k do
                 if abs(phi[i]-psi[i])>0.5*abs(s1[i]) then goto 2
           end;
        if d>=delta then
           begin if eval>max then goto 1000;
              d:=rho*d;
              for i:=1 to k do s1[i]:=rho*s1[i];
              goto 1
           end;{if d}
1000:   max:=eval
 END; {DirS178}
 {-----------------------------------------------------------}
 begin    {Main program }
       ClrScr;
       max:=1000;
       d:=0.2;
       psi[1]:=0.1; psi[2]:=0.3;

       directsearch(k,rh0,delta,min,d,spsi,max,psi);
       writeln(psi[1],psi[2]);
 end.