  program SplineT;

    USES Crt,Graph;
    const maxn=160;
    type  RealType = double;
          mass_n_Sm = array[1..maxn] of RealType;
    var
       s,u,h                 : RealType;
       n,m,i,j,k,nn          : integer;
       GraphDriver,GraphMode : integer;
       x,y,b,c,d : mass_n_Sm;
       Mx,My     : RealType;
{-------------------------------------------------------------------}
{$I SPLINE.PAS}
{--------------------------------------------------------------------}
     begin

       nn:=15;
       DetectGraph(GraphDriver,GraphMode);
       InitGraph(GraphDriver,GraphMode,'\tp\graph');
       OutText('    Test for Spline     26.05.91  ');
       for k:=1 to nn do
         begin
       { readln(m,n);} n:=18; m:=6;
       for i:=1 to n do
         begin
           x[i]:=2*pi*(i-1)/n;
           y[i]:=(nn-k)*50*(exp(-k*sqr(x[i]-pi)));
         end;

       spline(n,x,y,b,c,d);
       u:=0; h:=2*pi/(m*n);My:=0.5;
       s:=seval(n,u,x,y,b,c,d);
       Mx:=100;
       for j:=1 to n do
         putPixel(round(x[j]*Mx),348-round(y[j]*My),white);
       MoveTo(round(x[1]*Mx),348-round(y[1]*My));

       for j:=1 to m*n do
         begin
            u:=u+h;
            s:=seval(n,u,x,y,b,c,d);
{           writeln('u=',u:6:2,'   s=',s:8:1);}
            LineTo(round(u*Mx),348-round(s*My));
         end;
       end; {k}
       readln;
       ClearDevice;
       CloseGraph;
     end.

