 program testBandSolve;
 Uses Crt;
 const n=5; m=3;
 type
   mass_N = array[1..n] of real;
   mass_NM = array[1..n,1..m] of real;
 var
   eps          : real;
   signal       : boolean;
   i,j          : integer;
   c            : mass_NM;
   v            : mass_N;

{$I BANDSOLV.PAS}
 begin
   eps:=1E-13;
   c[1,1]:=0; c[1,2]:=1; c[1,3]:=2;
   c[2,1]:=3; c[2,2]:=4; c[2,3]:=5;
   c[3,1]:=7; c[3,2]:=8; c[3,3]:=9;
   c[4,1]:=2; c[4,2]:=6; c[4,3]:=0;
   c[5,1]:=4; c[5,2]:=5; c[5,3]:=0;

   BandSolve(c,n,m,eps,signal,v);
   writeln('signal=',signal);
   for i:=1 to n do
     write(v[i]);
   writeln;
   end.