 program testRunge;
  Uses RungeU;
  Const  n=2;
  type
     RealType = double;
     mass_n=array[1..n] of RealType;
  var
     i,j,k,nn           : integer;
     ss                 : integer; { this is a global parameter }
     hs                 : RealType;    { from the Runge }
     y,z,yfin           : mass_n;
     xfin,eta,eps,x     : RealType;
     prim               : boolean;
     lex                : array[1..10] of RealType;


  procedure FexR(x: realType; var y1; n: integer; var z1);
  var
      y                      : arrayType absolute y1;
      z                      : arrayType absolute z1;
  begin
       z[1]:=y[2];
       z[2]:=-y[1];
  end;

  Begin
    hs:=0.;
    x:=0.;
    y[1]:=0.;
    y[2]:=1.0;
    eps:=1e-7; eta:=1e-7;
    lex[1]:=1.0; lex[2]:=2.0; lex[3]:=4; lex[4]:=6.0; lex[5]:=7.0; nn:=5;

    prim:=true;
      for i:=1 to nn do
        begin
          xfin:=lex[i];
          Runge(FexR,x,y,n,eps,eta,xfin,prim,yfin);
          x:=xfin;  prim:=false;
          for j:=1 to 2 do y[j]:=yfin[j];
        end;

    writeln(yfin[1],yfin[2],xfin);
    writeln(sin(lex[nn]),cos(lex[nn]),lex[nn]);

  END.
